/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.ui.android.view;

import android.widget.ListView;
import it.tidalwave.ui.android.widget.PresentationModelAdapter;
import javax.annotation.Nonnull;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.Action;
import it.tidalwave.util.thread.ThreadType;
import it.tidalwave.util.thread.annotation.ThreadConfined;
import android.widget.Button;
import lombok.AccessLevel;
import lombok.NoArgsConstructor;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@NoArgsConstructor(access=AccessLevel.PRIVATE)
public final class Bindings 
  {
    @ThreadConfined(type=ThreadType.UI)
    public static void bind (final @Nonnull Button button, final @Nonnull Action action)
      {
        button.setOnClickListener(new ViewOnClickListenerAdapter(action));
        button.setEnabled(action.isEnabled());
        button.setText((String)action.getValue(Action.NAME));
        
        // FIXME: use a weak listener!
        action.addPropertyChangeListener(new PropertyChangeListener() 
          {
            @ThreadConfined(type=ThreadType.ANY)
            public void propertyChange (final @Nonnull PropertyChangeEvent event) 
              {
                if ("enabled".equals(event.getPropertyName()))
                  {
                    button.post(new Runnable()
                      {
                        public void run() 
                          {
                            button.setEnabled(action.isEnabled());
                          }
                      });
                  }
              } 
          });
      }

    public static void bind (final @Nonnull ListView listView,
                             final @Nonnull PresentationModelAdapter listAdapter) 
      {
        listView.setAdapter(listAdapter);
        listView.setOnItemClickListener(listAdapter.getOnItemClickListener());
      }
  }
